\documentclass[english]{article}

\usepackage{babel}
\usepackage{graphicx}
\usepackage{alltt}
\usepackage{url}
%\usepackage{ngerman}
\usepackage{color}
\usepackage{framed}
\usepackage{todonotes}
\usepackage{listings}

\title{\huge\sffamily\bfseries Review of Group 12 by Group 14}
\author{Luzian Bieri \and Lina Gehri \and Dominique Portenier \and Ian Boschung}
\date{\today}


\begin{document}
\maketitle

%% **** please observe the page limit ****
%% (it is not allowed to change the font size or page geometry to gain more space!)
%% comment or remove lines below before hand-in
%%{\large\textcolor{red}{Page limit: 15 pages.}}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\tableofcontents
\pagebreak


\section{Background}

\noindent {\bf Developers of the external system:} {\it Pascal Küng, Freya Murphy, Jiacheng Shen, Yunfan Zou} \\

\noindent {\bf Date of the review: \today }


\section{Report and Design Review}

% \textit{Study the documentation that came with the external system and evaluation. }

\subsection{System Architecture and Security Concepts}

% \textit{Is the chosen architecture well-suited for the tasks specified in the requirements? Are the security design decisions well motivated and justified? List positive and negative aspects for each question.}

\subsubsection{General Architecture}

From the report, it is not clear why so many different servers are needed. On one hand, following the principle of compartmentalization, it is not a bad idea. However, maintaining four servers, rather than four applications on one server adds unnecessarily more work to the system administrator, which is in contradiction to the principle of easy application of security measures.

\paragraph{Server Maintenance}
No clear plan for updating servers is given or considered. As it is not possible to reach the internet from the CA server, the backup server, or the database server keeping them up to date will be a lot more involved than just executing \verb+apt update+. Also, it is unclear, what happens if one of the five servers is rebooting after a system update. Although this is not a direct security problem, the system could reach an unexpected state. 

\paragraph{Firewall}
The Firewall settings by its own make sense. It is good practice, to close all ports, which are not used. However, using the non standardized ports 5001 and 5002 implements partially an security by obscurity approach. Especially for the database server, where port 3306 would be the standard for MySQL.

Also, white-listing the web server improves the security a bit, this measure by its own isn't enough, since IPs can easily be spoofed. Although, not explicitly mentioned in the report, this problem is handled implicitly by specifying, that the servers use certificate-based authentication when communication with each other. 

\paragraph{Network Settings}
The whole infrastructure is planned in such a way, that the web server is the only connection between the internet and the whole system. Although this is technically possible, it is not a very handy network configuration and requires four of five servers to be isolated from the internet, or - in other words - a lot of communication routed through the webserver. It does, however, provide an extra layer of security according to "{}no single point of failure"{} as even if something was configured wrongly in the firewall rules of one of those servers, as they are not connected to the internet.

\subsubsection{Authorization via Certificate}
Contrary to what the button might suggest, the certificate is not uploaded to the web server when it is verified. Rather a message consisting of a nonce and the current time gets signed in the browser using javascript's crypto library and the private key associated with the certificate. This signed message is then sent to the server in a challenge-like manner and verified.


\subsubsection{Passwords}
\paragraph{Authorization via Passwords}

The authors of the report decided to hash the passwords on the client without any security justification. Indeed, just hashing the passwords on the client by itself does not increase security in any way, but even decreases it. The reason only password hashes are stored in the database is that in case the content of the database is stolen and published, an attacker first needs to find a preimage of the hashed password which should be hard for good hash functions. But when the password is hashed directly on the client, this protection falls away: An attacker who knows the hash from the database can use it directly to log into the server because the server directly compares the received hash to the stored hash. Using this scheme, the hashing can be omitted completely: If the scenario is that an attacker can listen to the communication between client and server and sniff the password, this attacker can also sniff the hash and use it to start a repetition attack. A possible solution for that specific problem would be for the server to send some random bytes to the client every time and the client then hashing the concatenation of the password and the random bytes. 


\paragraph{Changing Passwords}
The system does not provide a plan to update a user's password. This is very problematic if a user's password gets corrupted or a user simply forgets the password. Also, the system administrators cannot change the user password other than updating the corresponding SHA1 hash in the user database by hand.

\subsubsection{Logging}
The logging method seems reasonable. One thing that is not clear from the report is if the log files are rotated from time to time. This might be necessary, as otherwise they get very large and it will take a long time to encrypt them and send them to the backup server. Another unanswered question is what kind of encryption scheme is used for the encryption thereof.

Another unanswered question is how the log-files are analyzed. The report says, that any unusual activity in the logs would quickly alert system administrators. So do they have to check the log files manually or do the system admins get a periodical report with the newest activities.


\subsubsection{Data Criticality}
The report says, that the root key is stored offline to protect its confidentiality and integrity. While this might not follow the simplicity principle, it is worth the trade-off by enhancing confidentiality and integrity according to the minimal exposure principle.

\subsubsection{Web Security}
Neither XSS attacks nor CSRF or SSTI attacks or countermeasures are mentioned in the report.




% \textit{
% Is the chosen architecture well-suited for the tasks specified in the requirements? Are the security design decisions well-motivated and justified? List positive and negative aspects for each question.}


\subsection{Risk Analysis}

% \textit{Is the risk analysis coherent and complete? That is, are all relevant assets, threat sources, and threats listed? 
%
% Are the risk definitions (likelihood, impact, and risk) reasonable?
%
% Are the countermeasures appropriate?}

In our opinion, the assets and threat sources are well-defined and complete. % However, it seems that there are many similar assets (all assets related to private keys), it would be reasonable to summarize ...\todo[inline]{too many priv. key assets pöbeln - i find why not} 

\paragraph{All Risks involving Nature as threat}
An off-site backup solution plus a distributed network of servers using e.g. a floating IP, which is acquired by another instance of the web server in case of an outage may mitigate most of the risks.

\paragraph{No 6: Skilled hacker: DoS attack} The impact of \textit{high} does not cohere with the definitions as a DOS attack does not cause a loss of any secrets or certificates. Furthermore the impact can be reduced using a protection service like Cloudflare. Such an attack can also be conducted by a script kiddie or an investigation subject (e.g. a large company). % guete sänf, I like

\paragraph{No 8/9: Hashing passwords to prevent stealing from credentials} As correctly stated, hashing - and salting - passwords prevents a hacker from finding the original passwords. However, since the passwords are client-side hashed, the hacker can just send the hash directly bypassing the Frontend. 

\paragraph{No 12: Countermeasures} Its is not fully clear what is encrypted in what way and whether the keys in use are symmetric or not.

% \paragraph{No 14: Skilled Hackers: Compromise signing key, allowing them to sign arbitrary user certificates} What does compromise mean in that sense, factorize, steal?  \todo{eine z viu?} Factorizing is very cost-intensive or even completely impossible to be done by a hacker no matter their skill. It is rather a question of financial resources. Both cases are rather unlikely. However, a close monitoring of the usage of the certificates to log in and a comparison with the known certificates (issued by the CA server) would lead to a  discovery of the compromised key, as the forged might not be known to the CA server. \todo{ja, de findi chli weird}

\paragraph{No 19: Skilled Hacker: Obtains user’s login credentials - Countermeasures}
"User credentials are highly secured." Is not very specific. Are they talking about the storage of the session token? The storage of the password on the user's side?

\paragraph{Evaluation Asset Logical Asset: User Credentials}
We are missing the case where a user loses their password.


\paragraph{No 21/22: Countermeasures}
It would also be good to have a password changing policy and some password requirements e.g. length, usage of special signs etc. 

\paragraph{No 24: Countermeasures}
The mentioned Countermeasures don't cover the case where an employee leaks their own credentials/private keys.


\paragraph{No 33/34: Skilled hacker: Steal private key and sign arbitrary certificates to impersonate users}
Since the key is not directly accessible from any services open to the external web, it is rather unlikely to be stolen from an external threat. No 34 seems more likely. 

\paragraph{No 40: Countermeasures}
Only backing up the CRL does not help in case it gets modified. Rather it has to be compared to an older version regularly and ensure that only additions have been conducted. Furthermore, it is not clear how the CRL can be changed by a hacker since it should be signed by with the server certificate. A changed CRL would therefore also mean that the server signing key is compromised.

\paragraph{No 45: Script kiddie/Skilled hacker: Compromise
system in some way, e.g. impersonating users or leaking user data}
About what systems are we talking, the workstations of the informant? An Admins machine? Depending on what system is meant the impact and the likeliness would have to be adjusted.

\paragraph{Some general remarks}
Even though mentioned as threats no evaluation has been conducted concerning \textit{Malware and Trojans}. Furthermore, the \textit{Investigation Subject} as threat source is not taken into account. If for example a large company or even a country is being investigated by iMovies, the subject of the investigation will pose a mighty adversary with much larger monetary and personnel resources than a single hacker or script kiddie. \\
Also, security flaws in 3rd party dependencies they used (such as Borg backup) are not considered.







\section{Implementation Review}
 
\subsection{Compliance with Requirements} 

% \textit{Does the system meet the functional and security requirements given in the assignment? Are they implemented correctly? If not, list any missing functionality or security measure.}


\subsubsection{Functional Requirements}

We tested all the required functionality and can confirm that everything works as required. We were a little bit irritated by the way the certificate authentication works: Instead of using client TLS as described in the TLS specification and available in all modern browsers, the group decided to implement their own version of client certificate authentication which works by generating a message that contains the current time, the serial number of the certificate and a random nonce and sending this message signed to the webserver, which then checks its validity. The decision to implement this part in the client side javascript is not justified and in our opinion, it is better to use the industry standard than to recreate code from scratch.

During the review we also remarked that the ca-server, the database server and the backup server don't have access to the internet. While this may be desirable for security in the short term, it also means that upgrading any of these systems is very complicated. For long term security it is very important to upgrade programs and include new bug fixes and the more complicated this procedure is, the more probable it gets delayed by system administrators.

\subsection{System Security Testing}

% \textit{Systematically investigate the system. Are the countermeasures implemented as described? Do you see any security problems? Analyze the system using both black-box as well as white-box testing.}


\subsubsection{Black-Box}
\paragraph{Functionality} The functional requirements are fulfilled.
\paragraph{nmap} Using nmap one can find out that there are two open ports on the web server, port 22 for SSH and port 443 for HTTPS. Also, the system runs Linux and the web server is an nginx version 1.14.2 server. The other systems cannot be scanned because they are not accessible from the internet.
\paragraph{Countermeasures} 
 Countermeasures 8 and 9 both mention the hashed passwords as a countermeasure to stealing user credentials. Analyzing the JavaScript code in the website's HTML file we found out that passwords are hashed on the client side. However, it is unclear whether they are rehashed on the server-side at this point. But we realized during the whitebox analysis that this is not the case and an attacker can just send the hash directly, bypassing the frontend.

\paragraph{CertID vulnerability} During the black-box analysis, we systematically modified some values of the request payloads/parameters using burp-suite. Interestingly the value of \texttt{certID} in the payload of the POST-request to \texttt{/manage\_certi-} \texttt{ficates} can be edited without any issues which enables us to presumably revoke certificates that do not belong to the logged-in user. This - and a related vulnerability - was verified in the white-box analysis. 
\\
\\
Apart from this, we were not able to find any problems during the black-box analysis.



\subsubsection{White-Box}
\paragraph{Countermeasures}
\begin{itemize}
\item The countermeasure for threats number 12 and 24: "Only system administrators, who are thoroughly vetted, are allowed access to the backup server." is not implemented as there is a user account with sudo rights (user pascal - not an administrator). However, there are no SSH keys for this user account.

\item The countermeasure for threat number 28: "Log files are append only." is not implemented. On the web server, one can without problem delete lines from "webserver.log" when logged in as web server (without using sudo). Also, lines from "dbserver.log" can be deleted on the database server and on the CA server lines from "caserver.log". They are, however, backed up, therefore, a threat agent needs to change the logs before the regular backup happens.

\item The countermeasure for threat number 30: "Only system admins have read permissions on log
files." is not implemented correctly. Everyone (owner, group, and other) has read permissions for the log files on the web server, CA server, and database server. Also, the directories where the log files are stored are accessible to everyone (read and execute permissions for everyone on the whole path).

\item When looking at the countermeasure for threat number 40: "Only system administrators have permission to access core CA files." it is not quite clear if it is fulfilled because "access" is not very specific and "core CA files" is not either. Anyone who is on the CA server has access permissions to all /home/caserver directories and read permissions for all files except the private key of the CA server.
\end{itemize}



\paragraph{Borg Backup Security Problem} \label{borg} The backup solution has a serious security problem. If an attacker finds a way onto the web server they can easily make their way to the backup server as well. When we logged into the web server with ssh we could see that there is a user called \verb+borgbackup+ as there is a folder called borgbackup in the home directory. As the borgbackup user has some interesting permissions we tried to execute \verb+su borgbackup+ and easily guessed the user's password which was borgbackup (this was not part of the credentials given to us). Now we were logged in as the borgbackup user. This user needs to be able to connect to the backup server via ssh to do the backup, therefore, we could now execute \verb+ssh borg@192.168.100.13+ to connect to the backup server as the borg user. Because the user is now called borg and not borgbackup it took a few tries until we figured that out. As borg user on the backup server, we have access to all backed-up files.  \\
The same thing also works when one is logged in to the CA-server or the database server.

\paragraph{Permissions on the backup server} When checking the permissions on the backup server, it became clear that all users have read permissions for the encrypted private key and password backups. Because it is all encrypted it is not as big a security risk but removing read permissions for anyone but the system administrator would have been a small step to more closely follow the principle of minimal exposure.

\paragraph{Certificates on the database server} There are backed up certificates on the database server which according to the system description should not be there.

\paragraph{Another note on the web server}
The web server fulfills three functionalities in this group's implementation: first, it renders and serves the user interface, second it is used to forward ssh to the database server, CA server, and backup server for ssh tunneling, third it acts as a quasi-reverse proxy for all requests on to the database and the CA-Server. E.g the POST-Request on the \texttt{/edit\_profile} endpoint creates an internal POST request on the database server's Flask API. The communication within the internal network is encrypted using TLS. Said setup makes an analysis of the communication rather tedious while the security advantages are not fully clear to us. If the web server is compromised the same security issues remain as if the communication happened unencrypted and the web server performs the SQL requests directly to the database hosted on a different system. 

\subsection{Backdoors}

\subsubsection{Shell Injection Attack}
The revoke endpoint on the CA server uses the passed serial number to construct the filename of the certificate. Python then executes an openssl shell command to create and update the certificate and the certificate revocation list. The serial number is passed from the web server unchanged to the CA server and is directly included in the filename. This creates two vulnerabilities: First, a user can revoke any certificate he wants by just altering the revoke certificate request slightly and sending a different serial number. The server never checks if the certificate with this serial number belongs to the user that is logged in. Second, a far more serious issue arises because an attacker can do shell injection attacks by terminating the actual command with a semicolon and then executing any shell command that the server has enough privileges to execute. Considering the borg backup security problem \ref{borg} this means one can compromise the backup server as well.
We tested both attacks by using burp suite. For the first one, we changed the certId value to 03. We could then use the CRL list to check if the attack worked.
For the second one, we change \texttt{certID=02} to \texttt{certID=02;touch test;} and then used the admin login to see if the test file was created. \\

\subsubsection{SQL Injection Attack in DB Connector}

In the db-connector file, there is one statement that is created differently than all the others: It uses the python format method to include parameters in the query string instead of a prepared statement. If one wants to exploit this vulnerability, there are a few security measurements in place to prevent it:
\begin{enumerate}
    \item TLS with client certificates: The internal communication uses TLS with client certificates, which would prevent any person from impersonating the web server if implemented correctly. When looking at the flask configuration, one can see the following two lines of code: \\
    \verb+context.verify_mode = ssl.CERT_REQUIRED+ and \\ \verb+context.check_hostname = False+. This means two things: We need to provide a valid certificate that is signed by the configured root CA to connect to the database server. This is not a problem for any employee of iMovies and for external attackers, such a certificate can be obtained by either hacking any of its employees or bribing one. The second thing we see from this is that the hostnames are not checked against anything and any valid certificate will be accepted, not only the certificate of the web server.
    \item Manual source IP checking in every endpoint: On the first line of every endpoint, the remote\_addr is compared with a hardcoded IP address to ensure that only the web server or backup server can execute certain functions. This means that we would need a way to route the packets via the web server, which we did not find.
    \item Firewall: The third obstacle is the firewall which only allows connections on ports 22 and 443. The database server on the other hand listens on port 5002. We also did not manage to circumvent this problem. Again, if we could find a way to route the packages via the web server host, this problem could probably be fixed.
\end{enumerate}
We also tried if we can manipulate the frontend somehow to send the request with a custom username, but with no luck. The only option that works is by using the first backdoor: When we have access to the webserver shell, we can send requests from the webserver to the database server on port 5002 and use the SQL injection to change any user data, passwords or switch the certificates belonging to certain users.


\subsubsection{Theoretical Race Condition When Creating New Certificate} \label{race-cond}

When a new certificate is requested, the certificate signing request, the private key, and the PKCS file are temporarily stored in a file. The web server executing this task is Flask in its default configuration, and starting from Flask 1.0, it uses multithreading to serve multiple clients concurrently. This could lead to a race condition where two clients simultaneously request a certificate. The first request handler generates his keypair and stores it in the temporary file, then the second request handler does the same, overwriting said temporary files. Now the first handler is using the content of those temporary files to finish his task and deliver the altered key and certificate, after which the second handler does the same for the second client. In the end, both clients could end up with the same certificate (so the first client receives the certificate of the second client) or both clients have their own certificate, but use the same private key.
Admittedly, it is hard to exploit this as it relies on exact timing, but in a scenario where the attacker has a lot of resources and can observe the network, the attacker could detect requests and try to send his own request a little bit before that to receive the key of the victim.

\section{Comparison}

% \textit{Compare your system with the external system you were given for the review. Are there any remarkable highlights in your system or the external system?}

\begin{itemize}
    \item Using BorgBackup as a backup solution provides a sleek solution enabling to save a complete history of the data. The advantages borg has over rsync, which we used, is that it allows to keep a history of all data efficiently by using compression and deduplication. However, the implementation was not secure and lead to a security vulnerability (see \ref{borg}).
    \item Our System realizes compartmentalization by using Docker Containers. This has multiple advantages over using separate VMs:
    \begin{enumerate}
        \item Docker containers can be replicated or started on different machines as needed.
        \item By needing fewer physical servers, we reduced costs and complexity.
        \item Dockers internal network settings are very flexible: We can create multiple networks and specify for each container to which networks it has access to and which it doesn't.
    \end{enumerate}
    \item They are storing their root key offline after signing a CA key which in turn is used to sign new certificates. In our system, we directly used the root key to sign the users certificates. This additional layer in the certificate chain greatly reduces the effort if one of the server certificates gets compromised: It is enough to revoke the server certificate (and with it all user certificates), generate a new one and ask all users to get new certificates. In our system, we would need to revoke the root certificate, create a new one, distribute it to all users and install it on all devices.
    \item Using openssh cli for cryptographic operations: In our implementation, we used the python library Cryptography to generate keys and certificates directly in python, whereas group 12 uses the openssh cli and the python command \verb+os.system+ for cryptographic operations. The advantage of using openssh is that it is a well tested tool that is used by many people and is updated regularly. On the other hand, the communication with this tool is a lot more susceptible to errors: When using \verb+os.system+, shell injection attacks can happen very fast and in order to pass data to and from the cli tool, one needs to rely on temporary files which can cause new problems (see \ref{race-cond}). Using a python library to achieve all this simplifies communication a lot, but the developer needs to be sure what he does because small errors in the way cryptographic functions are used can have big impacts on the security of the resulting data.
    
    
\end{itemize}


\end{document}

%%% Local Variables: 
%%% mode: latex
%%% TeX-master: "../../book"
%%% End: 
